Attribute VB_Name = "MultimediaBitmap"
Option Explicit

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' previous version 15 Sept 2009
' version 18 March 2011 : added LineBitmap
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Multimedia Bitmap Utility
' related to CBitmap.cls
' this file is to be inserted into application
' not to be modified
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' public member function
' - RGBToLong
' - LongToRGB
' - GetMBitmapColor
' - SetMBitmapColor
' - SetMBitmapPtr
' - CreateMBitmap
' - CreateMBitmapMask
' - InitMBitmap
' - ClearMBitmap
' - ClearMBitmapMask
' - ReadMBitmapFile
' - ConvertVBPictureToMBitmap
' - SaveMBitmapFile
' - CopyMBitmap
' - ScaleMBitmap
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' dependency:
'   mbmplop.dll
'   mbmpio.dll
'   mbmputl.dll
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'PERLU DISEMAK DAN DIPERBAIKI!
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Public Type RGBTRIPLE
    b As Byte
    g As Byte
    r As Byte
End Type



'API function mbmplop.dll
'========================
Public Declare Function BytePtrToLong Lib "mbmplop.dll" (data As Any) As Long
Public Declare Function BitmapIndex Lib "mbmplop.dll" (bmp As MBITMAP, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function MaskIndex Lib "mbmplop.dll" (bmp As MBITMAP, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function GetBitmapColor Lib "mbmplop.dll" (bmp As MBITMAP, ByVal idx As Long) As RGBTRIPLE
Public Declare Sub SetBitmapColor Lib "mbmplop.dll" (bmp As MBITMAP, ByVal idx As Long, col As RGBTRIPLE)

Public Declare Function IsRectApiEmpty Lib "mbmplop.dll" (rect As RECTAPI) As Long
Public Declare Function IsBitmapEmpty Lib "mbmplop.dll" (bmp As MBITMAP) As Long
Public Declare Function IsBitmapSameSize Lib "mbmplop.dll" (bmp1 As MBITMAP, bmp2 As MBITMAP) As Long
Public Declare Function CheckBitmapEquality Lib "mbmplop.dll" (bmp1 As MBITMAP, bmp2 As MBITMAP) As Long
Public Declare Function GetBitmapIntersection Lib "mbmplop.dll" (back As MBITMAP, fore As MBITMAP) As Long
Public Declare Function CopyNonIntersectionBitmap Lib "mbmplop.dll" (src As MBITMAP, dst As MBITMAP) As Long

'2 layer operation
Public Declare Function PasteBitmap Lib "mbmplop.dll" (back As MBITMAP, fore As MBITMAP, dest As MBITMAP) As Long
Public Declare Function BlendBitmap Lib "mbmplop.dll" (back As MBITMAP, fore As MBITMAP, dest As MBITMAP) As Long
Public Declare Function MergeBitmap Lib "mbmplop.dll" (back As MBITMAP, fore As MBITMAP, dest As MBITMAP) As Long
Public Declare Function SmoothBitmap Lib "mbmplop.dll" (back As MBITMAP, fore As MBITMAP, dest As MBITMAP) As Long
Public Declare Function PasteMaskedBitmap Lib "mbmplop.dll" (back As MBITMAP, fore As MBITMAP, dest As MBITMAP) As Long
Public Declare Function BlendMaskedBitmap Lib "mbmplop.dll" (back As MBITMAP, fore As MBITMAP, dest As MBITMAP) As Long
Public Declare Function MergeMaskedBitmap Lib "mbmplop.dll" (back As MBITMAP, fore As MBITMAP, dest As MBITMAP) As Long
Public Declare Function SmoothMaskedBitmap Lib "mbmplop.dll" (back As MBITMAP, fore As MBITMAP, dest As MBITMAP) As Long

'2 layer mask operation
Public Declare Function PasteBitmapMask Lib "mbmplop.dll" (back As MBITMAP, fore As MBITMAP, dest As MBITMAP) As Long

'1 layer operation
Public Declare Function CopyBitmap Lib "mbmplop.dll" (src As MBITMAP, dst As MBITMAP) As Long
Public Declare Function CopyMaskedBitmap Lib "mbmplop.dll" (src As MBITMAP, dst As MBITMAP) As Long
Public Declare Function AntiAliasBitmap Lib "mbmplop.dll" (src As MBITMAP, dst As MBITMAP) As Long
Public Declare Function AntiAliasMaskedBitmap Lib "mbmplop.dll" (src As MBITMAP, dst As MBITMAP) As Long
Public Declare Function ScaleBitmap Lib "mbmplop.dll" (src As MBITMAP, dst As MBITMAP) As Long
Public Declare Function ScaleMaskedBitmap Lib "mbmplop.dll" (src As MBITMAP, dst As MBITMAP) As Long
Public Declare Function DesaturateBitmap Lib "mbmplop.dll" (src As MBITMAP, dst As MBITMAP, ByVal percent As Byte) As Long
Public Declare Function GrayScaleBitmap Lib "mbmplop.dll" (src As MBITMAP, dst As MBITMAP) As Long
Public Declare Function DimBitmap Lib "mbmplop.dll" (src As MBITMAP, dst As MBITMAP, ByVal percent As Byte) As Long
Public Declare Function AttenuateBitmap Lib "mbmplop.dll" (src As MBITMAP, dst As MBITMAP, ByVal max As Byte) As Long

'API function mbmpio.dll
'=======================
Public Declare Function ReadBitmapInfo Lib "mbmpio.dll" (ByVal Filename As String, bmpHead As BITMAPFILEHEADER, bmpInfo As BITMAPINFOHEADER) As Long
Public Declare Function ReadBitmapPalette Lib "mbmpio.dll" (ByVal Filename As String, lpPalette As MPALETTE) As Long
Public Declare Function ReadBitmapFile Lib "mbmpio.dll" (ByVal Filename As String, bmp As MBITMAP) As Long
Public Declare Function SaveBitmapFile Lib "mbmpio.dll" (ByVal Filename As String, bmp As MBITMAP) As Long
Public Declare Function CreateMaskFromBitmap Lib "mbmpio.dll" (src As MBITMAP, dst As MBITMAP) As Long
Public Declare Function CreateBitmapFromMask Lib "mbmpio.dll" (src As MBITMAP, dst As MBITMAP) As Long

'API function mbmputl.dll
'========================
Public Declare Function CompareBitmap Lib "mbmputl.dll" (src As MBITMAP, dst As MBITMAP, parm As MBMPCOMPARE) As Long
Public Declare Function PointBitmap Lib "mbmputl.dll" (dst As MBITMAP, ByVal X As Long, ByVal Y As Long, color As RGBTRIPLE) As Long
Public Declare Function DashBitmap Lib "mbmputl.dll" (dst As MBITMAP, ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long, ByVal mask As Byte, ByVal multiplier As Long, color As RGBTRIPLE) As Long
Public Declare Function LineBitmap Lib "mbmputl.dll" (dst As MBITMAP, ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long, color As RGBTRIPLE) As Long

'Windows API
'===========
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (dst As Any, src As Any, ByVal size As Long)
Public Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Public Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hDC As Long) As Long
Public Declare Function GetDesktopWindow Lib "user32" () As Long

Public Const DIB_RGB_COLORS = 0

Public Type BITMAPFILEHEADER
  bfType As Integer
  bfSize As Long
  bfReserved1 As Integer
  bfReserved2 As Integer
  bfOffBits As Long
End Type

Public Type BITMAPINFOHEADER
  biSize As Long
  biWidth As Long
  biHeight As Long
  biPlanes As Integer
  biBitCount As Integer
  biCompression As Long
  biSizeImage As Long
  biXPelsPerMeter As Long
  biYPelsPerMeter As Long
  biClrUsed As Long
  biClrImportant As Long
End Type

Public Type RGBQUAD
  b As Byte
  g As Byte
  r As Byte
  a As Byte
End Type

Public Type BITMAPINFO
  bmiHeader As BITMAPINFOHEADER
  bmiColors As RGBQUAD
End Type

Public Type POINTAPI
  X As Long
  Y As Long
End Type

Public Type RECTAPI
  start As POINTAPI
  end As POINTAPI
End Type

'we use Byte instead of RGBTRIPLE to allow padding
'for bit member, we cannot use RGBTRIPLE

Public Type MBITMAP
  info As BITMAPINFO
  Width As Long
  Height As Long
  pad As Byte
  rect As RECTAPI
  masked As Byte
  bitPtr As Long
  maskPtr As Long
  bit() As Byte
  mask() As Byte
End Type

Public Type MPALETTE
  count As Long
  bitPtr As Long
  palette() As RGBQUAD
End Type

Public Type MBMPCOMPARE
  percent As Byte
  threshold As Byte
  optimize As Boolean
  lpPercent As Byte
End Type

'/////////////////////////////////
'// bitmap allocation

Private Function calcMBitmapPad(wdt As Long) As Long
  calcMBitmapPad = (3 * wdt) Mod 4
  If calcMBitmapPad Then calcMBitmapPad = 4 - calcMBitmapPad
End Function

Private Sub setMBitmapInfo(bmp As MBITMAP, wd As Long, ht As Long, Optional masked As Boolean = False)
  With bmp.info.bmiHeader
    .biBitCount = 24
    .biClrImportant = 0
    .biClrUsed = 0
    .biCompression = 0
    .biHeight = ht
    .biPlanes = 1
    .biSize = Len(bmp.info.bmiHeader)
    .biSizeImage = Len(bmp.info.bmiHeader)
    .biWidth = wd
    .biXPelsPerMeter = 2834
    .biYPelsPerMeter = 2834
  End With
  bmp.masked = masked
  bmp.Width = wd
  bmp.Height = ht
  bmp.pad = calcMBitmapPad(wd)
  bmp.rect.start.X = 0
  bmp.rect.start.Y = 0
  bmp.rect.end.X = -1
  bmp.rect.end.Y = -1
End Sub

Public Function RGBToLong(col As RGBQUAD) As Long
    RGBToLong = CLng(col.r) + CLng(col.g) * 256 + CLng(col.b) * 256 * 256
End Function

Public Function LongToRGB(col As Long) As RGBQUAD
  Dim tmp As Long

  tmp = col
  LongToRGB.r = tmp Mod 256
  tmp = tmp \ 256
  LongToRGB.g = tmp Mod 256
  LongToRGB.b = tmp \ 256
End Function

'zero based coordinate
'(0,0)=topleft picture
'(width-1,height-1)=bottomright picture

Public Function GetMBitmapColor(bmp As MBITMAP, X As Long, Y As Long) As RGBQUAD
    Dim offset As Long

    'optimization check
    If IsBitmapEmpty(bmp) Then Exit Function
    If X >= bmp.Width Then Exit Function
    If Y >= bmp.Height Then Exit Function

    offset = BitmapIndex(bmp, X, bmp.Height - Y - 1)
    GetMBitmapColor.r = bmp.bit(offset + 2)
    GetMBitmapColor.g = bmp.bit(offset + 1)
    GetMBitmapColor.b = bmp.bit(offset + 0)
    If bmp.masked Then GetMBitmapColor.a = bmp.mask(MaskIndex(bmp, X, bmp.Height - Y - 1))
End Function

Public Sub SetMBitmapColor(bmp As MBITMAP, X As Long, Y As Long, col As RGBQUAD)
    Dim offset As Long

    'optimization check
    If IsBitmapEmpty(bmp) Then Exit Sub
    If X >= bmp.Width Then Exit Sub
    If Y >= bmp.Height Then Exit Sub

    offset = BitmapIndex(bmp, X, bmp.Height - Y - 1)
    bmp.bit(offset + 2) = col.r
    bmp.bit(offset + 1) = col.g
    bmp.bit(offset + 0) = col.b
    If bmp.masked Then bmp.mask(MaskIndex(bmp, X, bmp.Height - Y - 1)) = col.a
End Sub

Public Sub SetMBitmapPtr(bmp As MBITMAP)
  On Error Resume Next
  bmp.bitPtr = BytePtrToLong(bmp.bit(0))
  bmp.maskPtr = BytePtrToLong(bmp.mask(0))
End Sub

Public Function CreateMBitmap(bmp As MBITMAP, wd As Long, ht As Long, Optional masked As Boolean = False) As Boolean
  Dim siz As Long

  'optimization check
  If wd < 0 Then Exit Function
  If ht < 0 Then Exit Function

  setMBitmapInfo bmp, wd, ht, masked
  siz = (3 * wd + bmp.pad) * ht - 1
  If siz < 0 Then siz = 0
  ReDim bmp.bit(siz)
  If masked Then
    siz = wd * ht - 1
    If siz < 0 Then siz = 0
    ReDim bmp.mask(siz)
  Else
    ReDim bmp.mask(0)
  End If
  SetMBitmapPtr bmp

  CreateMBitmap = True
End Function

Public Function CreateMBitmapMask(bmp As MBITMAP) As Boolean
  Dim siz As Long

  'optimization check
  If bmp.Width < 0 Then Exit Function
  If bmp.Height < 0 Then Exit Function

  siz = bmp.Width * bmp.Height - 1
  If siz < 0 Then siz = 0
  ReDim bmp.mask(siz)
  bmp.masked = True
  SetMBitmapPtr bmp

  CreateMBitmapMask = True
End Function

Public Function InitMBitmap(bmp As MBITMAP) As Boolean
  InitMBitmap = CreateMBitmap(bmp, 0, 0)
End Function

Public Function ClearMBitmap(bmp As MBITMAP) As Boolean
  ClearMBitmap = InitMBitmap(bmp)
End Function

Public Function ClearMBitmapMask(bmp As MBITMAP) As Boolean
  ReDim bmp.mask(0)
  bmp.masked = False
  bmp.maskPtr = 0
  ClearMBitmapMask = True
End Function

'////////////////////////////////////////////////
'// API auxiliary, auto allocation

Public Function ReadMBitmapFile(bmp As MBITMAP, file As String) As Long

  'reading picture supported by vb
  'return 0 = file not exist
  'return 1 = read successful
  'return 2 = invalid format
  'return 3 = bmp scanning not completed

  Dim bmpHead As BITMAPFILEHEADER
  Dim bmpInfo As BITMAPINFOHEADER
  Dim pic As StdPicture
  Dim res As Long

  'abort if file is not exist
  If Dir(file, vbHidden Or vbReadOnly) = "" Then Exit Function

  'try reading through mbmpio.dll
  If ReadBitmapInfo(file, bmpHead, bmpInfo) Then
    CreateMBitmap bmp, bmpInfo.biWidth, bmpInfo.biHeight, CBool(bmpHead.bfReserved1)
    If ReadBitmapFile(file, bmp) Then
      res = 1
      GoTo CleaningUp
    End If
  End If

  'cannot be read by mbmpio.dll
  'load all kind of picture format

  On Error Resume Next
  Set pic = LoadPicture(file)
  If Err.Number Then
    res = 2
    GoTo CleaningUp
  End If
  res = ConvertVBPictureToMBitmap(pic, bmp)

'cleaning up
CleaningUp:
  SetMBitmapPtr bmp
  ReDim tmpBit(0)
  Set pic = Nothing
  ReadMBitmapFile = res
End Function

Public Function ConvertVBPictureToMBitmap(pic As StdPicture, bmp As MBITMAP) As Long
  Dim res As Long

  Dim hw As Long
  Dim dc As Long
  Dim ht As Long
  Dim wd As Long
  Dim w1 As Long
  Dim tmpBit() As Byte
  Dim scanLine As Long

  'get picture information
  hw = GetDesktopWindow()
  dc = GetDC(hw)

  'no scalex function (vbhimetric and vbpixels)
  wd = pic.Width * 3.77952766418457E-02
  ht = pic.Height * 3.77952766418457E-02
  
  If wd > 10000 Or wd <= 0 Then GoTo CleaningUp
  If ht > 10000 Or ht <= 0 Then GoTo CleaningUp

  CreateMBitmap bmp, wd, ht
  w1 = 3 * wd + bmp.pad
  ReDim tmpBit(w1 * ht - 1)

  scanLine = GetDIBits(dc, pic.Handle, 0, ht, tmpBit(0), bmp.info, DIB_RGB_COLORS)
  ReleaseDC hw, dc

  If scanLine <> ht Then
    res = 3
    GoTo CleaningUp
  End If

  CopyMemory bmp.bit(0), tmpBit(0), w1 * ht
  res = 1

CleaningUp:
  ConvertVBPictureToMBitmap = res
End Function

Public Function SaveMBitmapFile(bmp As MBITMAP, file As String, Optional overwrite As Boolean = False) As Long

  'return 0 = file already exist
  'return 1 = save successful
  'return 2 = bitmap is uninitialized/invalid
  'return 3 = unable to save file

  Const EXT As String = ".XBVZNKLISDUSO"
  Dim res As Long
  Dim renaming As Boolean

  If IsBitmapEmpty(bmp) Then
    res = 2
    GoTo CleaningUp
  End If

  'if file already exist
  If Dir(file, vbHidden Or vbReadOnly) <> "" Then
    If Not overwrite Then Exit Function
    On Error Resume Next
    Name file As file + EXT
    If Err.Number Then
      res = 3
      GoTo CleaningUp
    Else
      renaming = True
    End If
    On Error GoTo 0
  End If

  'do the mbmpio.dll saving
  If SaveBitmapFile(file, bmp) Then
    res = 1
    GoTo CleaningUp
  End If

  'unable to save, restore original (existed) file
  If renaming Then
    Name file + EXT As file
    renaming = False
  End If
  res = 3

CleaningUp:
  On Error Resume Next
  If renaming Then Kill file + EXT
  SaveMBitmapFile = res
End Function

Public Function CopyMBitmap(src As MBITMAP, dst As MBITMAP, Optional masked As Boolean = False) As Boolean
  Dim res As Boolean

  'optimization check
  If IsBitmapEmpty(src) Then Exit Function
  If (Not src.masked) Then masked = False
  CreateMBitmap dst, src.Width, src.Height, masked

  If masked Then
    res = CopyMaskedBitmap(src, dst)
  Else
    res = CopyBitmap(src, dst)
  End If

  CopyMBitmap = res
End Function

Public Function ScaleMBitmap(bmp As MBITMAP, wdt As Long, hgt As Long, Optional masked As Boolean = False) As Boolean
  Dim tmp As MBITMAP
  Dim res As Boolean

  'optimization check
  If IsBitmapEmpty(bmp) Then Exit Function
  If (Not bmp.masked) Then masked = False
  CreateMBitmap tmp, wdt, hgt, masked

  If masked Then
    res = ScaleMaskedBitmap(bmp, tmp)
  Else
    res = ScaleBitmap(bmp, tmp)
  End If

  If res = 0 Then Exit Function
  ScaleMBitmap = CopyMBitmap(tmp, bmp, masked)
End Function
