Attribute VB_Name = "SoaJPEG"
Option Explicit

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Soa's JPEG Utility
' ver 1.0.0: 21 July 2009
'
' this file is to be inserted into application
' not to be modified
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' public member function
' - SaveAutoJPEGData
' - ReadAutoJPEGFile
' - ReadAutoJPEGData
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' dependency:
'   MultimediaBitmap.bas
'   soajpg.dll
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'PERLU DISEMAK DAN DIPERBAIKI!
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Public Const SOAJPG_SUCCESS As Long = 0
Public Const SOAJPG_ERROR_FILE As Long = -1
Public Const SOAJPG_ERROR_INTERNAL As Long = -2
Public Const SOAJPG_ERROR_NULL_IMAGE As Long = -3
Public Const SOAJPG_ERROR_INVALID_IMAGE As Long = -4

Public Const SOAJPG_ERROR_MEMORY As Long = -99

Public Const JDCT_ISLOW As Long = 0
Public Const JDCT_IFAST As Long = 1
Public Const JDCT_FLOAT As Long = 2
Public Const JDCT_DEFAULT As Long = JDCT_ISLOW
Public Const JDCT_FASTEST As Long = JDCT_IFAST

Public Type SOAJPG_INFO
    Width As Long
    Height As Long
    method As Long
    quality As Long
    bpp As Long
End Type

'API function soajpg.dll
'========================

Public Declare Sub SynchJPEGInfo Lib "soajpg.dll" (src As MBITMAP, info As SOAJPG_INFO)

Public Declare Function SaveJPEGFile Lib "soajpg.dll" (ByVal filename As String, src As MBITMAP, info As SOAJPG_INFO) As Long
Public Declare Function SaveJPEGData Lib "soajpg.dll" (src As MBITMAP, info As SOAJPG_INFO, dst As Any, dstSize As Long) As Long

Public Declare Function ReadJPEGFileHeader Lib "soajpg.dll" (ByVal filename As String, info As SOAJPG_INFO) As Long
Public Declare Function ReadJPEGFile Lib "soajpg.dll" (ByVal filename As String, dest As MBITMAP, info As SOAJPG_INFO) As Long

Public Declare Function ReadJPEGDataHeader Lib "soajpg.dll" (info As SOAJPG_INFO, src As Any, srcSize As Long) As Long
Public Declare Function ReadJPEGData Lib "soajpg.dll" (dst As MBITMAP, info As SOAJPG_INFO, src As Any, srcSize As Long) As Long

Public Declare Sub InvertJPEGImage Lib "soajpg.dll" (bmp As MBITMAP)

Public Function SaveAutoJPEGData(src As MBITMAP, info As SOAJPG_INFO, dst() As Byte, dstSize As Long) As Long
    dstSize = src.Width * src.Height * 3
    ReDim dst(dstSize)
    dstSize = SaveJPEGData(src, info, dst(0), dstSize)
    If dstSize > 0 Then ReDim Preserve dst(dstSize - 1)

    SaveAutoJPEGData = dstSize
End Function

Public Function ReadAutoJPEGFile(filename As String, dest As MBITMAP, info As SOAJPG_INFO) As Long
    Dim res As Long

    res = ReadJPEGFileHeader(filename, info)
    If res = SOAJPG_SUCCESS Then
        If CreateMBitmap(dest, info.Width, info.Height) Then
            res = ReadJPEGFile(filename, dest, info)
        Else
            res = SOAJPG_ERROR_MEMORY
        End If
    End If

    ReadAutoJPEGFile = res
End Function

Public Function ReadAutoJPEGData(dest As MBITMAP, info As SOAJPG_INFO, src() As Byte, srcSize As Long)
    Dim res As Long

    res = ReadJPEGDataHeader(info, src(0), srcSize)
    If res = SOAJPG_SUCCESS Then
        If CreateMBitmap(dest, info.Width, info.Height) Then
            res = ReadJPEGData(dest, info, src(0), srcSize)
        Else
            res = SOAJPG_ERROR_MEMORY
        End If
    End If

    ReadAutoJPEGData = res
End Function
